/*
 *  i2o.h
 *  
 *
 *  Created by Pacey, John Charles on 7/1/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 *	definitions and functions used to convert Iris GL to Open GL without rewriting the entire code
 *	NOTE: additional work will be necessary to convert individual files 
 *
 */
 
// includes -----------------------------------------------------------------------------------------------------
#pragma warning (disable:4305) /* double-to-float  */
#pragma warning (disable:4101)/*  unreferenced local variable */
#pragma warning (disable:4056)/*  bogus "overflow in floating-point */
#pragma warning (disable:4142)
#pragma warning (disable:4003)
#pragma warning (disable:4067)
#pragma warning (disable:4133)

#include <stdlib.h>
#include <stdio.h>
#include <OpenGL/gl.h>		// Header File For The OpenGL32 Library
#include <OpenGL/glu.h>		// Header File For The GLu32 Library
#include <GLUT/glut.h>		// Header File For The GLut Library
#include <math.h>
#include <sys/timeb.h>

// includes from previous file five011204.c
// not sure what they do

#include <stdarg.h>
#include <sys/types.h>


// IGL -> OGL General redefinitions  NOTE: new functions include both OpenGL and GLU
//					NOTE:  code specific redefinitions and functions follow
//							- specific to tcon.c
//---------------------------------------------------------------------------------------------------------------

#define acbuf			glAccum
#define acsize			ChoosePixelFormat
#define afunction		glAlphaFunc
#define arc				glPartialDisk
#define backbuffer		glDrawBuffer(GL_BACK)
#define bgnclosedline()	glBegin(GL_LINE_LOOP)
#define bgncurve		gluBeginCurve
#define bgnline()		glBegin(GL_LINE_STRIP)
#define bgnpoint()		glBegin(GL_POINTS)
#define bgnpolygon()	glBegin(GL_POLYGON)
#define bgnqstrip()		glBegin(GL_QUAD_STRIP)
#define bgnsurface		gluBeginSurface
#define bgntmesh()		glBegin(GL_TRIANGLE_STRIP)
#define bgntrim			gluBeginTrim
#define blendfunction	flBlenFunc
#define	circ			gluDisk
#define clear			glClear(GL_COLOR_BUFFER_BIT)
#define clipplane		glClipPlane
#define closobj			glEndList
#define cmode			ChoosePixelFormat
#define cmov			glRasterPos3
#define cmov2			glRasterPos2
#define color			glIndexf
#define concave			gluBeginPolygon
#define curvebasis		glMap1
#define curveit			glEvalMesh1
#define czclear			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
#define defbasis		glMap1
#define deflinestyle	glLineStipple
#define	defrasterfont	wglUseFontBitmaps
#define delobj			glDeleteLists
#define dither			glEnable(GL_DITHER)
#define doublebuffer	ChoosePixelFormat
#define drawmode		wglMakeCurrent
#define endclosedline	glEnd
#define	endcurve		gluEndCurve
#define endfeedback		glRenderMode(GL_RENDER)
#define endline			glEnd
#define endpick			glRenderMode(GL_RENDER)
#define endpoint		glEnd
#define endpolygon		glEnd
#define endqstrip		glEnd
#define endselect		glRenderMode(GL_RENDER)
#define endsurface		gluEndSurface
#define endtmesh		glEnd
#define endtrim			gluEndTrim
#define feedback		glFeedbackBuffer
#define finish			glFinish
#define fogvertex		glFog
#define font			glListBase
#define frontbuffer		glDrawBuffer(GL_FRONT)
#define frontface		glCullFace
#define genobj			glGenLists
#define	getbackface		glGet
#define getbuffer		glGet
#define getcmmode		wglGetCurrentContext
#define getcolor		glGet
#define getcpos			glGet
#define getdcm			glIsEnabled
#define getdepth		glGet
#define getdisplaymode  glGet
#define getmmode		glGet(GL_MATRIX_MODE)
#define getsm			glGet(GL_SHADE_MODEL)
#define getviewport		glGet(GL_VIEWPORT)
#define getzbuffer		glIsEnabled(GL_DEPTH_TEST)
#define gflush			glFlush
#define gRGBcolor		glGet(GL_CURRENT_RASTER_COLOR)
#define gselect			glSelectBuffer
#define gversion		glGetString(GL_RENERER)
#define initnames		glInitNames
#define isobj			glIsList
#define	linesmooth		glEnable(GL_LINE_SMOOTH)
#define loadmatrix		glLoadMatrixf
#define	lookat			gluLookAt
#define lsetdepth		glDepthRange
#define	mmode			glMatrixMode
#define	multmatrix		glMultMatrixf
#define n3f				glNormal3fv
#define ortho			glOrtho
#define ortho2			glOrtho2D
#define perspective		gluPerspective
#define popmatrix		glPopMatrix
#define pushmatrix		glPushMatrix
#define scale			glScalef
#define swapbuffers		glutSwapBuffers
#define translate		glTranslatef
#define v3f				glVertex3fv
#define viewport		glViewport
#define window			glFrustum
#define zbufffer()		glEnable(GL_DEPTH_TEST)
#define zclear()		glClear(GL_DEPTH_BUFFER_BIT)


// tcon.c specific definitions ---------------------------------------------------------------------------------
#define fsin        sin
#define fcos        cos
#define fsqrt       sqrt
#define rot			rotate
#define random      rand

// tcon.c key mapping
#define LEFTMOUSE  '[' 
#define RIGHTMOUSE  ']' 
#define ENDKEY 'e'
#define ESCKEY 27 
#define AKEY 'a'
#define BKEY 'b'
#define UKEY 'u'
#define JKEY 'j'
#define TKEY 't'
#define PKEY 'p'
#define QKEY 'q'
#define SKEY 's'
#define RKEY 'r'
#define IKEY 'i'
#define NKEY 'n'
#define HKEY 'h'
#define LKEY 'l'


// helper functions to convert IGL to OGL
//---------------------------------------------------------------------------------------------------------------

/**********************************************************************/
void cpack(long hexad){ 
   float red, green, blue;
   red   = (hexad & 255)/255.;
   green = ((hexad >> 8) & 255)/255.;
   blue =  ((hexad >> 16)& 255)/255.;
   glColor3f(red,green,blue);
 }

/*****************************************************************/
void rotate(float angle, char axis){  /* or int and glRotatei */
  switch(axis){
  case('x'): glRotatef(angle, 1.0, 0.0, 0.0 );  break;
  case('y'): glRotatef(angle, 0.0, 1.0, 0.0 );  break;
  case('z'): glRotatef(angle, 0.0, 0.0, 1.0 );  break;
  }
}
/*****************************************************************/
void linewidth(int thick){
	//int a; a=thick;
	glLineWidth((float)thick);
}

/**********************************************************************/
void backface(int flag){
   if(flag==1){
   glEnable(GL_CULL_FACE);
   glFrontFace(GL_CCW);
   } else /* flag ==0 */  
   glDisable(GL_CULL_FACE);
}
/**********************************************************************/

void getmatrix(float* mat){glGetFloatv(GL_MODELVIEW_MATRIX, mat);}

/**********************************************************************/
void char2wall(float x,float y,float z, char buf[]){
     char *p; glRasterPos3f(x,y,z);
     for(p = buf;*p;p++) glutBitmapCharacter(GLUT_BITMAP_9_BY_15,*p);
}
/**********************************************************************/
